import { useCallback, useEffect } from 'react';
import { useAppDispatch, useAppSelector } from '../../hooks';

import {
  AuthType,
  FilterDataType,
  HandleFormDataChangeType,
  HandleSearchResetType,
  HandleSearchTriggerType,
  HandleSearchType,
  SetToggleType,
  ToggleType,
  WithHocAuth,
  WithHocForm,
  WithHocSearch,
  WithHocToggle,
} from '../../components';

import logo from '../../assets/img/logo.svg';
import sdwLogo from '../../assets/img/logo.png';
import './App.scss';

export const App = ({
  auth,
  filterData,
  handleFormDataChange,
  toggle,
  setToggle,
  handleSearch,
  handleSearchTrigger,
  handleSearchReset,
}: {
  auth: AuthType;
  filterData: FilterDataType;
  handleFormDataChange: HandleFormDataChangeType;
  toggle: ToggleType;
  setToggle: SetToggleType;
  handleSearch: HandleSearchType;
  handleSearchTrigger: HandleSearchTriggerType,
  handleSearchReset: HandleSearchResetType,
}) => {
  const dispatch = useAppDispatch();

  return (
    <header className='App-header'>
      <div className='cont'>
        <img
          src={sdwLogo}
          className='sdw-logo d-block mg-auto'
          alt='SDW logo'
        />

        <img src={logo} className='App-logo' alt='logo' />
        <p>Edit <code>src/App.tsx</code> and save to reload.</p>

        <a
          className='App-link'
          href='https://reactjs.org'
          target='_blank'
          rel='noopener noreferrer'
        >
          Learn React
        </a>
      </div>
    </header>
  );
};

export const AppWithHoc = WithHocAuth(
  WithHocForm(
    WithHocToggle(
      WithHocSearch(App)
    )
  )
);
